#define MEMC_PHY_BASE                                   0x10810000

#define ATLAS7_MEMC_PHY_RIDR		(MEMC_PHY_BASE + 0x000)
#define ATLAS7_MEMC_PHY_PIR		(MEMC_PHY_BASE + 0x004)
#define ATLAS7_MEMC_PHY_PGCR0		(MEMC_PHY_BASE + 0x008)
#define ATLAS7_MEMC_PHY_PGCR1		(MEMC_PHY_BASE + 0x00c)
#define ATLAS7_MEMC_PHY_PGSR0		(MEMC_PHY_BASE + 0x010)
#define ATLAS7_MEMC_PHY_PGSR1		(MEMC_PHY_BASE + 0x014)
#define ATLAS7_MEMC_PHY_PLLCR		(MEMC_PHY_BASE + 0x018)
#define ATLAS7_MEMC_PHY_PTR0		(MEMC_PHY_BASE + 0x01c)
#define ATLAS7_MEMC_PHY_PTR1		(MEMC_PHY_BASE + 0x020)
#define ATLAS7_MEMC_PHY_PTR2		(MEMC_PHY_BASE + 0x024)
#define ATLAS7_MEMC_PHY_PTR3		(MEMC_PHY_BASE + 0x028)
#define ATLAS7_MEMC_PHY_PTR4		(MEMC_PHY_BASE + 0x02c)
#define ATLAS7_MEMC_PHY_ACMDLR		(MEMC_PHY_BASE + 0x030)
#define ATLAS7_MEMC_PHY_ACBDLR		(MEMC_PHY_BASE + 0x034)
#define ATLAS7_MEMC_PHY_ACIOCR		(MEMC_PHY_BASE + 0x038)
#define ATLAS7_MEMC_PHY_DXCCR		(MEMC_PHY_BASE + 0x03c)
#define ATLAS7_MEMC_PHY_DSGCR		(MEMC_PHY_BASE + 0x040)
#define ATLAS7_MEMC_PHY_DCR		(MEMC_PHY_BASE + 0x044)
#define ATLAS7_MEMC_PHY_DTPR0		(MEMC_PHY_BASE + 0x048)
#define ATLAS7_MEMC_PHY_DTPR1		(MEMC_PHY_BASE + 0x04c)
#define ATLAS7_MEMC_PHY_DTPR2		(MEMC_PHY_BASE + 0x050)
#define ATLAS7_MEMC_PHY_MR0		(MEMC_PHY_BASE + 0x054)
#define ATLAS7_MEMC_PHY_MR1		(MEMC_PHY_BASE + 0x058)
#define ATLAS7_MEMC_PHY_MR2		(MEMC_PHY_BASE + 0x05c)
#define ATLAS7_MEMC_PHY_MR3		(MEMC_PHY_BASE + 0x060)
#define ATLAS7_MEMC_PHY_ODTCR		(MEMC_PHY_BASE + 0x064)
#define ATLAS7_MEMC_PHY_DTCR		(MEMC_PHY_BASE + 0x068)
#define ATLAS7_MEMC_PHY_DTAR0		(MEMC_PHY_BASE + 0x06c)
#define ATLAS7_MEMC_PHY_DTAR1		(MEMC_PHY_BASE + 0x070)
#define ATLAS7_MEMC_PHY_DTAR2		(MEMC_PHY_BASE + 0x074)
#define ATLAS7_MEMC_PHY_DTAR3		(MEMC_PHY_BASE + 0x078)
#define ATLAS7_MEMC_PHY_DTDR0		(MEMC_PHY_BASE + 0x07c)
#define ATLAS7_MEMC_PHY_DTDR1		(MEMC_PHY_BASE + 0x080)
#define ATLAS7_MEMC_PHY_DTEDR0		(MEMC_PHY_BASE + 0x084)
#define ATLAS7_MEMC_PHY_DTEDR1		(MEMC_PHY_BASE + 0x088)
#define ATLAS7_MEMC_PHY_PGCR2		(MEMC_PHY_BASE + 0x08c)
#define ATLAS7_MEMC_PHY_RDIMMGCR0		(MEMC_PHY_BASE + 0x0b0)
#define ATLAS7_MEMC_PHY_RDIMMGCR1		(MEMC_PHY_BASE + 0x0b4)
#define ATLAS7_MEMC_PHY_RDIMMCR0		(MEMC_PHY_BASE + 0x0b8)
#define ATLAS7_MEMC_PHY_RDIMMCR1		(MEMC_PHY_BASE + 0x0bc)
#define ATLAS7_MEMC_PHY_DCUAR		(MEMC_PHY_BASE + 0x0c0)
#define ATLAS7_MEMC_PHY_DCUDR		(MEMC_PHY_BASE + 0x0c4)
#define ATLAS7_MEMC_PHY_DCURR		(MEMC_PHY_BASE + 0x0c8)
#define ATLAS7_MEMC_PHY_DCULR		(MEMC_PHY_BASE + 0x0cc)
#define ATLAS7_MEMC_PHY_DCUGCR		(MEMC_PHY_BASE + 0x0d0)
#define ATLAS7_MEMC_PHY_DCUTPR		(MEMC_PHY_BASE + 0x0d4)
#define ATLAS7_MEMC_PHY_DCUSR0		(MEMC_PHY_BASE + 0x0d8)
#define ATLAS7_MEMC_PHY_DCUSR1		(MEMC_PHY_BASE + 0x0dc)
#define ATLAS7_MEMC_PHY_BISTRR		(MEMC_PHY_BASE + 0x100)
#define ATLAS7_MEMC_PHY_BISTWCR		(MEMC_PHY_BASE + 0x104)
#define ATLAS7_MEMC_PHY_BISTMSKR0		(MEMC_PHY_BASE + 0x108)
#define ATLAS7_MEMC_PHY_BISTMSKR1		(MEMC_PHY_BASE + 0x10c)
#define ATLAS7_MEMC_PHY_BISTMSKR2		(MEMC_PHY_BASE + 0x110)
#define ATLAS7_MEMC_PHY_BISTLSR		(MEMC_PHY_BASE + 0x114)
#define ATLAS7_MEMC_PHY_BISTAR0		(MEMC_PHY_BASE + 0x118)
#define ATLAS7_MEMC_PHY_BISTAR1		(MEMC_PHY_BASE + 0x11c)
#define ATLAS7_MEMC_PHY_BISTAR2		(MEMC_PHY_BASE + 0x120)
#define ATLAS7_MEMC_PHY_BISTUDPR		(MEMC_PHY_BASE + 0x124)
#define ATLAS7_MEMC_PHY_BISTGSR		(MEMC_PHY_BASE + 0x128)
#define ATLAS7_MEMC_PHY_BISTWER		(MEMC_PHY_BASE + 0x12c)
#define ATLAS7_MEMC_PHY_BISTBER0		(MEMC_PHY_BASE + 0x130)
#define ATLAS7_MEMC_PHY_BISTBER1		(MEMC_PHY_BASE + 0x134)
#define ATLAS7_MEMC_PHY_BISTBER2		(MEMC_PHY_BASE + 0x138)
#define ATLAS7_MEMC_PHY_BISTBER3		(MEMC_PHY_BASE + 0x13c)
#define ATLAS7_MEMC_PHY_BISTWCSR		(MEMC_PHY_BASE + 0x140)
#define ATLAS7_MEMC_PHY_BISTFWR0		(MEMC_PHY_BASE + 0x144)
#define ATLAS7_MEMC_PHY_BISTFWR1		(MEMC_PHY_BASE + 0x148)
#define ATLAS7_MEMC_PHY_BISTFWR2		(MEMC_PHY_BASE + 0x14c)
#define ATLAS7_MEMC_PHY_AACR		(MEMC_PHY_BASE + 0x174)
#define ATLAS7_MEMC_PHY_ZQ0CR0		(MEMC_PHY_BASE + 0x180)
#define ATLAS7_MEMC_PHY_ZQ0CR1		(MEMC_PHY_BASE + 0x184)
#define ATLAS7_MEMC_PHY_ZQ0SR0		(MEMC_PHY_BASE + 0x188)
#define ATLAS7_MEMC_PHY_ZQ0SR1		(MEMC_PHY_BASE + 0x18c)
#define ATLAS7_MEMC_PHY_DX0GCR		(MEMC_PHY_BASE + 0x1c0)
#define ATLAS7_MEMC_PHY_DX0GSR0		(MEMC_PHY_BASE + 0x1c4)
#define ATLAS7_MEMC_PHY_DX0GSR1		(MEMC_PHY_BASE + 0x1c8)
#define ATLAS7_MEMC_PHY_DX0BDLR0		(MEMC_PHY_BASE + 0x1cc)
#define ATLAS7_MEMC_PHY_DX0BDLR1		(MEMC_PHY_BASE + 0x1d0)
#define ATLAS7_MEMC_PHY_DX0BDLR2		(MEMC_PHY_BASE + 0x1d4)
#define ATLAS7_MEMC_PHY_DX0BDLR3		(MEMC_PHY_BASE + 0x1d8)
#define ATLAS7_MEMC_PHY_DX0BDLR4		(MEMC_PHY_BASE + 0x1dc)
#define ATLAS7_MEMC_PHY_DX0LCDLR0		(MEMC_PHY_BASE + 0x1e0)
#define ATLAS7_MEMC_PHY_DX0LCDLR1		(MEMC_PHY_BASE + 0x1e4)
#define ATLAS7_MEMC_PHY_DX0LCDLR2		(MEMC_PHY_BASE + 0x1e8)
#define ATLAS7_MEMC_PHY_DX0MDLR		(MEMC_PHY_BASE + 0x1ec)
#define ATLAS7_MEMC_PHY_DX0GTR		(MEMC_PHY_BASE + 0x1f0)
#define ATLAS7_MEMC_PHY_DX0GSR2		(MEMC_PHY_BASE + 0x1f4)
#define ATLAS7_MEMC_PHY_DX1GCR		(MEMC_PHY_BASE + 0x200)
#define ATLAS7_MEMC_PHY_DX1GSR0		(MEMC_PHY_BASE + 0x204)
#define ATLAS7_MEMC_PHY_DX1GSR1		(MEMC_PHY_BASE + 0x208)
#define ATLAS7_MEMC_PHY_DX1BDLR0		(MEMC_PHY_BASE + 0x20c)
#define ATLAS7_MEMC_PHY_DX1BDLR1		(MEMC_PHY_BASE + 0x210)
#define ATLAS7_MEMC_PHY_DX1BDLR2		(MEMC_PHY_BASE + 0x214)
#define ATLAS7_MEMC_PHY_DX1BDLR3		(MEMC_PHY_BASE + 0x218)
#define ATLAS7_MEMC_PHY_DX1BDLR4		(MEMC_PHY_BASE + 0x21c)
#define ATLAS7_MEMC_PHY_DX1LCDLR0		(MEMC_PHY_BASE + 0x220)
#define ATLAS7_MEMC_PHY_DX1LCDLR1		(MEMC_PHY_BASE + 0x224)
#define ATLAS7_MEMC_PHY_DX1LCDLR2		(MEMC_PHY_BASE + 0x228)
#define ATLAS7_MEMC_PHY_DX1MDLR		(MEMC_PHY_BASE + 0x22c)
#define ATLAS7_MEMC_PHY_DX1GTR		(MEMC_PHY_BASE + 0x230)
#define ATLAS7_MEMC_PHY_DX1GSR2		(MEMC_PHY_BASE + 0x234)
#define ATLAS7_MEMC_PHY_LUT_AC_PD0  (MEMC_PHY_BASE + 0x400)
#define ATLAS7_MEMC_PHY_LUT_AC_PU0  (MEMC_PHY_BASE + 0x480)
#define ATLAS7_MEMC_PHY_LUT_CLK_PD0 (MEMC_PHY_BASE + 0x500)
#define ATLAS7_MEMC_PHY_LUT_CLK_PU0 (MEMC_PHY_BASE + 0x580)
/* fields for register ATLAS7_MEMC_PHY_RIDR */
#define ATLAS7_MEMC_PHY_RIDR_PUBMNR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PUBMNR_SHIFT		0
#define ATLAS7_MEMC_PHY_RIDR_PUBMDR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PUBMDR_SHIFT		4
#define ATLAS7_MEMC_PHY_RIDR_PUBMJR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PUBMJR_SHIFT		8
#define ATLAS7_MEMC_PHY_RIDR_PHYMNR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PHYMNR_SHIFT		12
#define ATLAS7_MEMC_PHY_RIDR_PHYMDR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PHYMDR_SHIFT		16
#define ATLAS7_MEMC_PHY_RIDR_PHYMJR_MASK		0xf
#define ATLAS7_MEMC_PHY_RIDR_PHYMJR_SHIFT		20
#define ATLAS7_MEMC_PHY_RIDR_UDRID_MASK		0xff
#define ATLAS7_MEMC_PHY_RIDR_UDRID_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_PIR */
#define ATLAS7_MEMC_PHY_PIR_INIT		BIT(0)
#define ATLAS7_MEMC_PHY_PIR_ZCAL		BIT(1)
#define ATLAS7_MEMC_PHY_PIR_PLLINIT		BIT(4)
#define ATLAS7_MEMC_PHY_PIR_DCAL		BIT(5)
#define ATLAS7_MEMC_PHY_PIR_PHYRST		BIT(6)
#define ATLAS7_MEMC_PHY_PIR_DRAMRST		BIT(7)
#define ATLAS7_MEMC_PHY_PIR_DRAMINIT		BIT(8)
#define ATLAS7_MEMC_PHY_PIR_WL		BIT(9)
#define ATLAS7_MEMC_PHY_PIR_QSGATE		BIT(10)
#define ATLAS7_MEMC_PHY_PIR_WLADJ		BIT(11)
#define ATLAS7_MEMC_PHY_PIR_RDDSKW		BIT(12)
#define ATLAS7_MEMC_PHY_PIR_WRDSKW		BIT(13)
#define ATLAS7_MEMC_PHY_PIR_RDEYE		BIT(14)
#define ATLAS7_MEMC_PHY_PIR_WREYE		BIT(15)
#define ATLAS7_MEMC_PHY_PIR_ICPC		BIT(16)
#define ATLAS7_MEMC_PHY_PIR_PLLBYP		BIT(17)
#define ATLAS7_MEMC_PHY_PIR_CTLDINIT		BIT(18)
#define ATLAS7_MEMC_PHY_PIR_RDIMMINIT		BIT(19)
#define ATLAS7_MEMC_PHY_PIR_CLRSR		BIT(27)
#define ATLAS7_MEMC_PHY_PIR_LOCKBYP		BIT(28)
#define ATLAS7_MEMC_PHY_PIR_DCALBYP		BIT(29)
#define ATLAS7_MEMC_PHY_PIR_ZCALBYP		BIT(30)
#define ATLAS7_MEMC_PHY_PIR_INITBYP		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_PGCR0 */
#define ATLAS7_MEMC_PHY_PGCR0_WLLVT		BIT(0)
#define ATLAS7_MEMC_PHY_PGCR0_WDLVT		BIT(1)
#define ATLAS7_MEMC_PHY_PGCR0_RDLVT		BIT(2)
#define ATLAS7_MEMC_PHY_PGCR0_RGLVT		BIT(3)
#define ATLAS7_MEMC_PHY_PGCR0_WDBVT		BIT(4)
#define ATLAS7_MEMC_PHY_PGCR0_RDBVT		BIT(5)
#define ATLAS7_MEMC_PHY_PGCR0_DLTMODE		BIT(6)
#define ATLAS7_MEMC_PHY_PGCR0_DLTST		BIT(7)
#define ATLAS7_MEMC_PHY_PGCR0_OSCEN		BIT(8)
#define ATLAS7_MEMC_PHY_PGCR0_OSCDIV_MASK		0x7
#define ATLAS7_MEMC_PHY_PGCR0_OSCDIV_SHIFT		9
#define ATLAS7_MEMC_PHY_PGCR0_OSCWDL_MASK		0x3
#define ATLAS7_MEMC_PHY_PGCR0_OSCWDL_SHIFT		12
#define ATLAS7_MEMC_PHY_PGCR0_DTOSEL_MASK		0x1f
#define ATLAS7_MEMC_PHY_PGCR0_DTOSEL_SHIFT		14
#define ATLAS7_MEMC_PHY_PGCR0_PUBMODE		BIT(25)
#define ATLAS7_MEMC_PHY_PGCR0_CKEN_MASK		0x3f
#define ATLAS7_MEMC_PHY_PGCR0_CKEN_SHIFT		26

/* fields for register ATLAS7_MEMC_PHY_PGCR1 */
#define ATLAS7_MEMC_PHY_PGCR1_PDDISDX		BIT(0)
#define ATLAS7_MEMC_PHY_PGCR1_WLMODE		BIT(1)
#define ATLAS7_MEMC_PHY_PGCR1_WLSTEP		BIT(2)
#define ATLAS7_MEMC_PHY_PGCR1_WSLOPT		BIT(4)
#define ATLAS7_MEMC_PHY_PGCR1_ACHRST		BIT(5)
#define ATLAS7_MEMC_PHY_PGCR1_WLSELT		BIT(6)
#define ATLAS7_MEMC_PHY_PGCR1_MDLEN		BIT(9)
#define ATLAS7_MEMC_PHY_PGCR1_LPFEN		BIT(10)
#define ATLAS7_MEMC_PHY_PGCR1_LPFDEPTH_MASK		0x3
#define ATLAS7_MEMC_PHY_PGCR1_LPFDEPTH_SHIFT		11
#define ATLAS7_MEMC_PHY_PGCR1_FDEPTH_MASK		0x3
#define ATLAS7_MEMC_PHY_PGCR1_FDEPTH_SHIFT		13
#define ATLAS7_MEMC_PHY_PGCR1_DLDLMT_MASK		0xff
#define ATLAS7_MEMC_PHY_PGCR1_DLDLMT_SHIFT		15
#define ATLAS7_MEMC_PHY_PGCR1_ZCKSEL_MASK		0x3
#define ATLAS7_MEMC_PHY_PGCR1_ZCKSEL_SHIFT		23
#define ATLAS7_MEMC_PHY_PGCR1_DXHRST		BIT(25)
#define ATLAS7_MEMC_PHY_PGCR1_INHVT		BIT(26)
#define ATLAS7_MEMC_PHY_PGCR1_IOLB		BIT(27)
#define ATLAS7_MEMC_PHY_PGCR1_LBDQSS		BIT(28)
#define ATLAS7_MEMC_PHY_PGCR1_LBGDQS_MASK		0x3
#define ATLAS7_MEMC_PHY_PGCR1_LBGDQS_SHIFT		29
#define ATLAS7_MEMC_PHY_PGCR1_LBMODE		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_PGSR0 */
#define ATLAS7_MEMC_PHY_PGSR0_IDONE		BIT(0)
#define ATLAS7_MEMC_PHY_PGSR0_PLDONE		BIT(1)
#define ATLAS7_MEMC_PHY_PGSR0_DCDONE		BIT(2)
#define ATLAS7_MEMC_PHY_PGSR0_ZCDONE		BIT(3)
#define ATLAS7_MEMC_PHY_PGSR0_DIDONE		BIT(4)
#define ATLAS7_MEMC_PHY_PGSR0_WLDONE		BIT(5)
#define ATLAS7_MEMC_PHY_PGSR0_QSGDONE		BIT(6)
#define ATLAS7_MEMC_PHY_PGSR0_WLADONE		BIT(7)
#define ATLAS7_MEMC_PHY_PGSR0_RDDONE		BIT(8)
#define ATLAS7_MEMC_PHY_PGSR0_WDDONE		BIT(9)
#define ATLAS7_MEMC_PHY_PGSR0_REDONE		BIT(10)
#define ATLAS7_MEMC_PHY_PGSR0_WEDONE		BIT(11)
#define ATLAS7_MEMC_PHY_PGSR0_ZCERR		BIT(20)
#define ATLAS7_MEMC_PHY_PGSR0_WLERR		BIT(21)
#define ATLAS7_MEMC_PHY_PGSR0_QSGERR		BIT(22)
#define ATLAS7_MEMC_PHY_PGSR0_WLAERR		BIT(23)
#define ATLAS7_MEMC_PHY_PGSR0_RDERR		BIT(24)
#define ATLAS7_MEMC_PHY_PGSR0_WDERR		BIT(25)
#define ATLAS7_MEMC_PHY_PGSR0_REERR		BIT(26)
#define ATLAS7_MEMC_PHY_PGSR0_WEERR		BIT(27)
#define ATLAS7_MEMC_PHY_PGSR0_PLDONE_CHN_MASK		0x3
#define ATLAS7_MEMC_PHY_PGSR0_PLDONE_CHN_SHIFT		28
#define ATLAS7_MEMC_PHY_PGSR0_APLOCK		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_PGSR1 */
#define ATLAS7_MEMC_PHY_PGSR1_DLTDONE		BIT(0)
#define ATLAS7_MEMC_PHY_PGSR1_DLTCODE_MASK		0xffffff
#define ATLAS7_MEMC_PHY_PGSR1_DLTCODE_SHIFT		1
#define ATLAS7_MEMC_PHY_PGSR1_VTSTOP		BIT(30)
#define ATLAS7_MEMC_PHY_PGSR1_PARERR		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_PLLCR */
#define ATLAS7_MEMC_PHY_PLLCR_DTC_MASK		0x3
#define ATLAS7_MEMC_PHY_PLLCR_DTC_SHIFT		0
#define ATLAS7_MEMC_PHY_PLLCR_ATC_MASK		0xf
#define ATLAS7_MEMC_PHY_PLLCR_ATC_SHIFT		2
#define ATLAS7_MEMC_PHY_PLLCR_ATOEN_MASK		0xf
#define ATLAS7_MEMC_PHY_PLLCR_ATOEN_SHIFT		6
#define ATLAS7_MEMC_PHY_PLLCR_GSHIFT		BIT(10)
#define ATLAS7_MEMC_PHY_PLLCR_CPIC_MASK		0x3
#define ATLAS7_MEMC_PHY_PLLCR_CPIC_SHIFT		11
#define ATLAS7_MEMC_PHY_PLLCR_CPPC_MASK		0xf
#define ATLAS7_MEMC_PHY_PLLCR_CPPC_SHIFT		13
#define ATLAS7_MEMC_PHY_PLLCR_QPMODE		BIT(17)
#define ATLAS7_MEMC_PHY_PLLCR_FRQSEL_MASK		0x3
#define ATLAS7_MEMC_PHY_PLLCR_FRQSEL_SHIFT		18
#define ATLAS7_MEMC_PHY_PLLCR_PLLPD		BIT(29)
#define ATLAS7_MEMC_PHY_PLLCR_PLLRST		BIT(30)
#define ATLAS7_MEMC_PHY_PLLCR_BYP		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_PTR0 */
#define ATLAS7_MEMC_PHY_PTR0_TPHYRST_MASK		0x3f
#define ATLAS7_MEMC_PHY_PTR0_TPHYRST_SHIFT		0
#define ATLAS7_MEMC_PHY_PTR0_TPLLGS_MASK		0x7fff
#define ATLAS7_MEMC_PHY_PTR0_TPLLGS_SHIFT		6
#define ATLAS7_MEMC_PHY_PTR0_TPLLPD_MASK		0x7ff
#define ATLAS7_MEMC_PHY_PTR0_TPLLPD_SHIFT		21

/* fields for register ATLAS7_MEMC_PHY_PTR1 */
#define ATLAS7_MEMC_PHY_PTR1_TPLLRST_MASK		0x1fff
#define ATLAS7_MEMC_PHY_PTR1_TPLLRST_SHIFT		0
#define ATLAS7_MEMC_PHY_PTR1_TPLLLOCK_MASK		0xffff
#define ATLAS7_MEMC_PHY_PTR1_TPLLLOCK_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_PTR2 */
#define ATLAS7_MEMC_PHY_PTR2_TCALON_MASK		0x1f
#define ATLAS7_MEMC_PHY_PTR2_TCALON_SHIFT		0
#define ATLAS7_MEMC_PHY_PTR2_TCALS_MASK		0x1f
#define ATLAS7_MEMC_PHY_PTR2_TCALS_SHIFT		5
#define ATLAS7_MEMC_PHY_PTR2_TCALH_MASK		0x1f
#define ATLAS7_MEMC_PHY_PTR2_TCALH_SHIFT		10
#define ATLAS7_MEMC_PHY_PTR2_TWLDLYS_MASK		0x1f
#define ATLAS7_MEMC_PHY_PTR2_TWLDLYS_SHIFT		15

/* fields for register ATLAS7_MEMC_PHY_PTR3 */
#define ATLAS7_MEMC_PHY_PTR3_TDINIT0_MASK		0xfffff
#define ATLAS7_MEMC_PHY_PTR3_TDINIT0_SHIFT		0
#define ATLAS7_MEMC_PHY_PTR3_TDINIT1_MASK		0x1ff
#define ATLAS7_MEMC_PHY_PTR3_TDINIT1_SHIFT		20

/* fields for register ATLAS7_MEMC_PHY_PTR4 */
#define ATLAS7_MEMC_PHY_PTR4_TDINIT2_MASK		0x3ffff
#define ATLAS7_MEMC_PHY_PTR4_TDINIT2_SHIFT		0
#define ATLAS7_MEMC_PHY_PTR4_TDINIT3_MASK		0x3ff
#define ATLAS7_MEMC_PHY_PTR4_TDINIT3_SHIFT		18

/* fields for register ATLAS7_MEMC_PHY_ACMDLR */
#define ATLAS7_MEMC_PHY_ACMDLR_IPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_ACMDLR_IPRD_SHIFT		0
#define ATLAS7_MEMC_PHY_ACMDLR_TPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_ACMDLR_TPRD_SHIFT		8
#define ATLAS7_MEMC_PHY_ACMDLR_MDLD_MASK		0xff
#define ATLAS7_MEMC_PHY_ACMDLR_MDLD_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_ACBDLR */
#define ATLAS7_MEMC_PHY_ACBDLR_CK0BD_MASK		0x3f
#define ATLAS7_MEMC_PHY_ACBDLR_CK0BD_SHIFT		0
#define ATLAS7_MEMC_PHY_ACBDLR_CK1BD_MASK		0x3f
#define ATLAS7_MEMC_PHY_ACBDLR_CK1BD_SHIFT		6
#define ATLAS7_MEMC_PHY_ACBDLR_CK2BD_MASK		0x3f
#define ATLAS7_MEMC_PHY_ACBDLR_CK2BD_SHIFT		12
#define ATLAS7_MEMC_PHY_ACBDLR_ACBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_ACBDLR_ACBD_SHIFT		18

/* fields for register ATLAS7_MEMC_PHY_ACIOCR */
#define ATLAS7_MEMC_PHY_ACIOCR_ACIOM		BIT(0)
#define ATLAS7_MEMC_PHY_ACIOCR_ACOE		BIT(1)
#define ATLAS7_MEMC_PHY_ACIOCR_ACODT		BIT(2)
#define ATLAS7_MEMC_PHY_ACIOCR_ACPDD		BIT(3)
#define ATLAS7_MEMC_PHY_ACIOCR_ACPDR		BIT(4)
#define ATLAS7_MEMC_PHY_ACIOCR_CKODT		BIT(5)
#define ATLAS7_MEMC_PHY_ACIOCR_CKPDD		BIT(8)
#define ATLAS7_MEMC_PHY_ACIOCR_CKPDR		BIT(11)
#define ATLAS7_MEMC_PHY_ACIOCR_RANKODT		BIT(14)
#define ATLAS7_MEMC_PHY_ACIOCR_CSPDD		BIT(18)
#define ATLAS7_MEMC_PHY_ACIOCR_RANKPDR		BIT(22)
#define ATLAS7_MEMC_PHY_ACIOCR_RSTODT		BIT(26)
#define ATLAS7_MEMC_PHY_ACIOCR_RSTPDD		BIT(27)
#define ATLAS7_MEMC_PHY_ACIOCR_RSTPDR		BIT(28)
#define ATLAS7_MEMC_PHY_ACIOCR_RSTIOM		BIT(29)

/* fields for register ATLAS7_MEMC_PHY_DXCCR */
#define ATLAS7_MEMC_PHY_DXCCR_DXODT		BIT(0)
#define ATLAS7_MEMC_PHY_DXCCR_DXIOM		BIT(1)
#define ATLAS7_MEMC_PHY_DXCCR_MDLEN		BIT(2)
#define ATLAS7_MEMC_PHY_DXCCR_DXPDD		BIT(3)
#define ATLAS7_MEMC_PHY_DXCCR_DXPDR		BIT(4)
#define ATLAS7_MEMC_PHY_DXCCR_DQSRES_MASK		0xf
#define ATLAS7_MEMC_PHY_DXCCR_DQSRES_SHIFT		5
#define ATLAS7_MEMC_PHY_DXCCR_DQSNRES_MASK		0xf
#define ATLAS7_MEMC_PHY_DXCCR_DQSNRES_SHIFT		9
#define ATLAS7_MEMC_PHY_DXCCR_MSBUDQ_MASK		0x7
#define ATLAS7_MEMC_PHY_DXCCR_MSBUDQ_SHIFT		15
#define ATLAS7_MEMC_PHY_DXCCR_UDQODT		BIT(18)
#define ATLAS7_MEMC_PHY_DXCCR_UDQPDD		BIT(19)
#define ATLAS7_MEMC_PHY_DXCCR_UDQPDR		BIT(20)
#define ATLAS7_MEMC_PHY_DXCCR_UDQIOM		BIT(21)
#define ATLAS7_MEMC_PHY_DXCCR_DYNDXPDD		BIT(22)
#define ATLAS7_MEMC_PHY_DXCCR_DYNDXPDR		BIT(23)
#define ATLAS7_MEMC_PHY_DXCCR_DDPDDCDO_MASK		0xf
#define ATLAS7_MEMC_PHY_DXCCR_DDPDDCDO_SHIFT		24
#define ATLAS7_MEMC_PHY_DXCCR_DDPDRCDO_MASK		0xf
#define ATLAS7_MEMC_PHY_DXCCR_DDPDRCDO_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DSGCR */
#define ATLAS7_MEMC_PHY_DSGCR_PUREN		BIT(0)
#define ATLAS7_MEMC_PHY_DSGCR_BDISEN		BIT(1)
#define ATLAS7_MEMC_PHY_DSGCR_ZUEN		BIT(2)
#define ATLAS7_MEMC_PHY_DSGCR_LPIOPD		BIT(3)
#define ATLAS7_MEMC_PHY_DSGCR_LPPLLPD		BIT(4)
#define ATLAS7_MEMC_PHY_DSGCR_CUAEN		BIT(5)
#define ATLAS7_MEMC_PHY_DSGCR_DQSGX		BIT(6)
#define ATLAS7_MEMC_PHY_DSGCR_BRRMODE		BIT(7)
#define ATLAS7_MEMC_PHY_DSGCR_PUAD_MASK		0xf
#define ATLAS7_MEMC_PHY_DSGCR_PUAD_SHIFT		8
#define ATLAS7_MEMC_PHY_DSGCR_DTOODT		BIT(12)
#define ATLAS7_MEMC_PHY_DSGCR_DTOPDD		BIT(13)
#define ATLAS7_MEMC_PHY_DSGCR_DTOPDR		BIT(14)
#define ATLAS7_MEMC_PHY_DSGCR_DTOIOM		BIT(15)
#define ATLAS7_MEMC_PHY_DSGCR_DTOOE		BIT(16)
#define ATLAS7_MEMC_PHY_DSGCR_ATOAE		BIT(17)
#define ATLAS7_MEMC_PHY_DSGCR_RRMODE		BIT(18)
#define ATLAS7_MEMC_PHY_DSGCR_SDRMODE		BIT(19)
#define ATLAS7_MEMC_PHY_DSGCR_CKEPDD		BIT(20)
#define ATLAS7_MEMC_PHY_DSGCR_ODTPDD		BIT(24)
#define ATLAS7_MEMC_PHY_DSGCR_CKOE		BIT(28)
#define ATLAS7_MEMC_PHY_DSGCR_ODTOE		BIT(29)
#define ATLAS7_MEMC_PHY_DSGCR_RSTOE		BIT(30)
#define ATLAS7_MEMC_PHY_DSGCR_CKEOE		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_DCR */
#define ATLAS7_MEMC_PHY_DCR_DDRMD_MASK		0x7
#define ATLAS7_MEMC_PHY_DCR_DDRMD_SHIFT		0
#define ATLAS7_MEMC_PHY_DCR_DDR8BNK		BIT(3)
#define ATLAS7_MEMC_PHY_DCR_PDQ_MASK		0x7
#define ATLAS7_MEMC_PHY_DCR_PDQ_SHIFT		4
#define ATLAS7_MEMC_PHY_DCR_MPRDQ		BIT(7)
#define ATLAS7_MEMC_PHY_DCR_BYTEMASK_MASK		0xff
#define ATLAS7_MEMC_PHY_DCR_BYTEMASK_SHIFT		10
#define ATLAS7_MEMC_PHY_DCR_NOSRA		BIT(27)
#define ATLAS7_MEMC_PHY_DCR_DDR2T		BIT(28)
#define ATLAS7_MEMC_PHY_DCR_UDIMM		BIT(29)

/* fields for register ATLAS7_MEMC_PHY_DTPR0 */
#define ATLAS7_MEMC_PHY_DTPR0_TRTP_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR0_TRTP_SHIFT		0
#define ATLAS7_MEMC_PHY_DTPR0_TWTR_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR0_TWTR_SHIFT		4
#define ATLAS7_MEMC_PHY_DTPR0_TRP_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR0_TRP_SHIFT		8
#define ATLAS7_MEMC_PHY_DTPR0_TRCD_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR0_TRCD_SHIFT		12
#define ATLAS7_MEMC_PHY_DTPR0_TRAS_MASK		0x3f
#define ATLAS7_MEMC_PHY_DTPR0_TRAS_SHIFT		16
#define ATLAS7_MEMC_PHY_DTPR0_TRRD_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR0_TRRD_SHIFT		22
#define ATLAS7_MEMC_PHY_DTPR0_TRC_MASK		0x3f
#define ATLAS7_MEMC_PHY_DTPR0_TRC_SHIFT		26

/* fields for register ATLAS7_MEMC_PHY_DTPR1 */
#define ATLAS7_MEMC_PHY_DTPR1_TMRD_MASK		0x3
#define ATLAS7_MEMC_PHY_DTPR1_TMRD_SHIFT		0
#define ATLAS7_MEMC_PHY_DTPR1_TMOD_MASK		0x7
#define ATLAS7_MEMC_PHY_DTPR1_TMOD_SHIFT		2
#define ATLAS7_MEMC_PHY_DTPR1_TFAW_MASK		0x3f
#define ATLAS7_MEMC_PHY_DTPR1_TFAW_SHIFT		5
#define ATLAS7_MEMC_PHY_DTPR1_TRFC_MASK		0x1ff
#define ATLAS7_MEMC_PHY_DTPR1_TRFC_SHIFT		11
#define ATLAS7_MEMC_PHY_DTPR1_TWLMRD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DTPR1_TWLMRD_SHIFT		20
#define ATLAS7_MEMC_PHY_DTPR1_TWLO_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR1_TWLO_SHIFT		26
#define ATLAS7_MEMC_PHY_DTPR1_TAOND_TAOFD_MASK		0x3
#define ATLAS7_MEMC_PHY_DTPR1_TAOND_TAOFD_SHIFT		30

/* fields for register ATLAS7_MEMC_PHY_DTPR2 */
#define ATLAS7_MEMC_PHY_DTPR2_TXS_MASK		0x3ff
#define ATLAS7_MEMC_PHY_DTPR2_TXS_SHIFT		0
#define ATLAS7_MEMC_PHY_DTPR2_TXP_MASK		0x1f
#define ATLAS7_MEMC_PHY_DTPR2_TXP_SHIFT		10
#define ATLAS7_MEMC_PHY_DTPR2_TCKE_MASK		0xf
#define ATLAS7_MEMC_PHY_DTPR2_TCKE_SHIFT		15
#define ATLAS7_MEMC_PHY_DTPR2_TDLLK_MASK		0x3ff
#define ATLAS7_MEMC_PHY_DTPR2_TDLLK_SHIFT		19
#define ATLAS7_MEMC_PHY_DTPR2_TRTODT		BIT(29)
#define ATLAS7_MEMC_PHY_DTPR2_TRTW		BIT(30)
#define ATLAS7_MEMC_PHY_DTPR2_TCCD		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_MR0 */
#define ATLAS7_MEMC_PHY_MR0_BL_MASK		0x3
#define ATLAS7_MEMC_PHY_MR0_BL_SHIFT		0
#define ATLAS7_MEMC_PHY_MR0_CL_0		BIT(2)
#define ATLAS7_MEMC_PHY_MR0_BT		BIT(3)
#define ATLAS7_MEMC_PHY_MR0_CL_MASK		0x7
#define ATLAS7_MEMC_PHY_MR0_CL_SHIFT		4
#define ATLAS7_MEMC_PHY_MR0_TM		BIT(7)
#define ATLAS7_MEMC_PHY_MR0_DR		BIT(8)
#define ATLAS7_MEMC_PHY_MR0_WR_MASK		0x7
#define ATLAS7_MEMC_PHY_MR0_WR_SHIFT		9
#define ATLAS7_MEMC_PHY_MR0_PD		BIT(12)
#define ATLAS7_MEMC_PHY_MR0_RSVD_MASK		0x7
#define ATLAS7_MEMC_PHY_MR0_RSVD_SHIFT		13

/* fields for register ATLAS7_MEMC_PHY_MR1 */
#define ATLAS7_MEMC_PHY_MR1_DE		BIT(0)
#define ATLAS7_MEMC_PHY_MR1_AL_MASK		0x3
#define ATLAS7_MEMC_PHY_MR1_AL_SHIFT		3
#define ATLAS7_MEMC_PHY_MR1_LEVEL		BIT(7)
#define ATLAS7_MEMC_PHY_MR1_TDQS		BIT(11)
#define ATLAS7_MEMC_PHY_MR1_QOFF		BIT(12)
#define ATLAS7_MEMC_PHY_MR1_RSVD_MASK		0x7
#define ATLAS7_MEMC_PHY_MR1_RSVD_SHIFT		13

/* fields for register ATLAS7_MEMC_PHY_MR2 */
#define ATLAS7_MEMC_PHY_MR2_PASR_MASK		0x7
#define ATLAS7_MEMC_PHY_MR2_PASR_SHIFT		0
#define ATLAS7_MEMC_PHY_MR2_CWL_MASK		0x7
#define ATLAS7_MEMC_PHY_MR2_CWL_SHIFT		3
#define ATLAS7_MEMC_PHY_MR2_ASR		BIT(6)
#define ATLAS7_MEMC_PHY_MR2_SRT		BIT(7)
#define ATLAS7_MEMC_PHY_MR2_RTTWR_MASK		0x3
#define ATLAS7_MEMC_PHY_MR2_RTTWR_SHIFT		9
#define ATLAS7_MEMC_PHY_MR2_RSVD_MASK		0x1f
#define ATLAS7_MEMC_PHY_MR2_RSVD_SHIFT		11

/* fields for register ATLAS7_MEMC_PHY_MR3 */
#define ATLAS7_MEMC_PHY_MR3_MPRLOC_MASK		0x3
#define ATLAS7_MEMC_PHY_MR3_MPRLOC_SHIFT		0
#define ATLAS7_MEMC_PHY_MR3_MPR		BIT(2)
#define ATLAS7_MEMC_PHY_MR3_RSVD_MASK		0x1fff
#define ATLAS7_MEMC_PHY_MR3_RSVD_SHIFT		3

/* fields for register ATLAS7_MEMC_PHY_ODTCR */
#define ATLAS7_MEMC_PHY_ODTCR_RDODT0		BIT(0)
#define ATLAS7_MEMC_PHY_ODTCR_WRODT0		BIT(16)

/* fields for register ATLAS7_MEMC_PHY_DTCR */
#define ATLAS7_MEMC_PHY_DTCR_DTRPTN_MASK		0xf
#define ATLAS7_MEMC_PHY_DTCR_DTRPTN_SHIFT		0
#define ATLAS7_MEMC_PHY_DTCR_DTRANK_MASK		0x3
#define ATLAS7_MEMC_PHY_DTCR_DTRANK_SHIFT		4
#define ATLAS7_MEMC_PHY_DTCR_DTMPR		BIT(6)
#define ATLAS7_MEMC_PHY_DTCR_DTCMPD		BIT(7)
#define ATLAS7_MEMC_PHY_DTCR_DTWDQM_MASK		0xf
#define ATLAS7_MEMC_PHY_DTCR_DTWDQM_SHIFT		8
#define ATLAS7_MEMC_PHY_DTCR_DTWBDDM		BIT(12)
#define ATLAS7_MEMC_PHY_DTCR_DTBDC		BIT(13)
#define ATLAS7_MEMC_PHY_DTCR_DTWDQMO		BIT(14)
#define ATLAS7_MEMC_PHY_DTCR_DTDBS_MASK		0xf
#define ATLAS7_MEMC_PHY_DTCR_DTDBS_SHIFT		16
#define ATLAS7_MEMC_PHY_DTCR_DTDEN		BIT(20)
#define ATLAS7_MEMC_PHY_DTCR_DTDSTP		BIT(21)
#define ATLAS7_MEMC_PHY_DTCR_DTEXD		BIT(22)
#define ATLAS7_MEMC_PHY_DTCR_DTEXG		BIT(23)
#define ATLAS7_MEMC_PHY_DTCR_RANKEN		BIT(24)
#define ATLAS7_MEMC_PHY_DTCR_RFSHDT_MASK		0xf
#define ATLAS7_MEMC_PHY_DTCR_RFSHDT_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DTAR0 */
#define ATLAS7_MEMC_PHY_DTAR0_DTCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_DTAR0_DTCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_DTAR0_DTROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_DTAR0_DTROW_SHIFT		12
#define ATLAS7_MEMC_PHY_DTAR0_DTBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_DTAR0_DTBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DTAR1 */
#define ATLAS7_MEMC_PHY_DTAR1_DTCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_DTAR1_DTCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_DTAR1_DTROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_DTAR1_DTROW_SHIFT		12
#define ATLAS7_MEMC_PHY_DTAR1_DTBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_DTAR1_DTBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DTAR2 */
#define ATLAS7_MEMC_PHY_DTAR2_DTCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_DTAR2_DTCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_DTAR2_DTROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_DTAR2_DTROW_SHIFT		12
#define ATLAS7_MEMC_PHY_DTAR2_DTBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_DTAR2_DTBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DTAR3 */
#define ATLAS7_MEMC_PHY_DTAR3_DTCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_DTAR3_DTCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_DTAR3_DTROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_DTAR3_DTROW_SHIFT		12
#define ATLAS7_MEMC_PHY_DTAR3_DTBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_DTAR3_DTBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DTDR0 */
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE0_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE0_SHIFT		0
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE1_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE1_SHIFT		8
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE2_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE2_SHIFT		16
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE3_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR0_DTBYTE3_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DTDR1 */
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE4_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE4_SHIFT		0
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE5_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE5_SHIFT		8
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE6_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE6_SHIFT		16
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE7_MASK		0xff
#define ATLAS7_MEMC_PHY_DTDR1_DTBYTE7_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DTEDR0 */
#define ATLAS7_MEMC_PHY_DTEDR0_DTWLMN_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR0_DTWLMN_SHIFT		0
#define ATLAS7_MEMC_PHY_DTEDR0_DTWLMX_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR0_DTWLMX_SHIFT		8
#define ATLAS7_MEMC_PHY_DTEDR0_DTWBMN_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR0_DTWBMN_SHIFT		16
#define ATLAS7_MEMC_PHY_DTEDR0_DTWBMX_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR0_DTWBMX_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DTEDR1 */
#define ATLAS7_MEMC_PHY_DTEDR1_DTRLMN_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR1_DTRLMN_SHIFT		0
#define ATLAS7_MEMC_PHY_DTEDR1_DTRLMX_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR1_DTRLMX_SHIFT		8
#define ATLAS7_MEMC_PHY_DTEDR1_DTRBMN_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR1_DTRBMN_SHIFT		16
#define ATLAS7_MEMC_PHY_DTEDR1_DTRBMX_MASK		0xff
#define ATLAS7_MEMC_PHY_DTEDR1_DTRBMX_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_PGCR2 */
#define ATLAS7_MEMC_PHY_PGCR2_TREFPRD_MASK		0x3ffff
#define ATLAS7_MEMC_PHY_PGCR2_TREFPRD_SHIFT		0
#define ATLAS7_MEMC_PHY_PGCR2_NOBUB		BIT(18)
#define ATLAS7_MEMC_PHY_PGCR2_FXDLAT		BIT(19)
#define ATLAS7_MEMC_PHY_PGCR2_DTPMXTMR_MASK		0xff
#define ATLAS7_MEMC_PHY_PGCR2_DTPMXTMR_SHIFT		20
#define ATLAS7_MEMC_PHY_PGCR2_SHRAC		BIT(28)
#define ATLAS7_MEMC_PHY_PGCR2_ACPDDC		BIT(29)
#define ATLAS7_MEMC_PHY_PGCR2_LPMSTRC0		BIT(30)
#define ATLAS7_MEMC_PHY_PGCR2_DYNACPDD		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_RDIMMGCR0 */
#define ATLAS7_MEMC_PHY_RDIMMGCR0_RDIMM		BIT(0)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERRNOREG		BIT(1)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_SOPERR		BIT(2)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_PARINODT		BIT(14)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_PARINPDD		BIT(15)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_PARINPDR		BIT(16)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_PARINIOM		BIT(17)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_PARINOE		BIT(18)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERROUTODT		BIT(19)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERROUTPDD		BIT(20)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERROUTPDR		BIT(21)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERROUTIOM		BIT(22)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_ERROUTOE		BIT(23)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_RDIMMODT		BIT(24)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_RDIMMPDD		BIT(25)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_RDIMMPDR		BIT(26)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_RDIMMIOM		BIT(27)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_QCSENOE		BIT(28)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_MIRROROE		BIT(29)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_QCSEN		BIT(30)
#define ATLAS7_MEMC_PHY_RDIMMGCR0_MIRROR		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_RDIMMGCR1 */
#define ATLAS7_MEMC_PHY_RDIMMGCR1_TBCSTAB_MASK		0xfff
#define ATLAS7_MEMC_PHY_RDIMMGCR1_TBCSTAB_SHIFT		0
#define ATLAS7_MEMC_PHY_RDIMMGCR1_TBCMRD_MASK		0x7
#define ATLAS7_MEMC_PHY_RDIMMGCR1_TBCMRD_SHIFT		12
#define ATLAS7_MEMC_PHY_RDIMMGCR1_CRINIT_MASK		0xffff
#define ATLAS7_MEMC_PHY_RDIMMGCR1_CRINIT_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_RDIMMCR0 */
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC0_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC0_SHIFT		0
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC1_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC1_SHIFT		4
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC2_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC2_SHIFT		8
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC3_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC3_SHIFT		12
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC4_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC4_SHIFT		16
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC5_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC5_SHIFT		20
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC6_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC6_SHIFT		24
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC7_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR0_RC7_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_RDIMMCR1 */
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC8_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC8_SHIFT		0
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC9_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC9_SHIFT		4
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC10_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC10_SHIFT		8
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC11_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC11_SHIFT		12
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC12_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC12_SHIFT		16
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC13_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC13_SHIFT		20
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC14_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC14_SHIFT		24
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC15_MASK		0xf
#define ATLAS7_MEMC_PHY_RDIMMCR1_RC15_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DCUAR */
#define ATLAS7_MEMC_PHY_DCUAR_CWADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCUAR_CWADDR_SHIFT		0
#define ATLAS7_MEMC_PHY_DCUAR_CSADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCUAR_CSADDR_SHIFT		4
#define ATLAS7_MEMC_PHY_DCUAR_CSEL_MASK		0x3
#define ATLAS7_MEMC_PHY_DCUAR_CSEL_SHIFT		8
#define ATLAS7_MEMC_PHY_DCUAR_INCA		BIT(10)
#define ATLAS7_MEMC_PHY_DCUAR_ATYPE		BIT(11)

/* fields for register ATLAS7_MEMC_PHY_DCUDR */
#define ATLAS7_MEMC_PHY_DCUDR_CDATA_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_DCUDR_CDATA_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_DCURR */
#define ATLAS7_MEMC_PHY_DCURR_DINST_MASK		0xf
#define ATLAS7_MEMC_PHY_DCURR_DINST_SHIFT		0
#define ATLAS7_MEMC_PHY_DCURR_SADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCURR_SADDR_SHIFT		4
#define ATLAS7_MEMC_PHY_DCURR_EADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCURR_EADDR_SHIFT		8
#define ATLAS7_MEMC_PHY_DCURR_NFAIL_MASK		0xff
#define ATLAS7_MEMC_PHY_DCURR_NFAIL_SHIFT		12
#define ATLAS7_MEMC_PHY_DCURR_SONF		BIT(20)
#define ATLAS7_MEMC_PHY_DCURR_SCOF		BIT(21)
#define ATLAS7_MEMC_PHY_DCURR_RCEN		BIT(22)
#define ATLAS7_MEMC_PHY_DCURR_XCEN		BIT(23)

/* fields for register ATLAS7_MEMC_PHY_DCULR */
#define ATLAS7_MEMC_PHY_DCULR_LSADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCULR_LSADDR_SHIFT		0
#define ATLAS7_MEMC_PHY_DCULR_LEADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCULR_LEADDR_SHIFT		4
#define ATLAS7_MEMC_PHY_DCULR_LCNT_MASK		0xff
#define ATLAS7_MEMC_PHY_DCULR_LCNT_SHIFT		8
#define ATLAS7_MEMC_PHY_DCULR_LINF		BIT(16)
#define ATLAS7_MEMC_PHY_DCULR_IDA		BIT(17)
#define ATLAS7_MEMC_PHY_DCULR_XLEADDR_MASK		0xf
#define ATLAS7_MEMC_PHY_DCULR_XLEADDR_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_DCUGCR */
#define ATLAS7_MEMC_PHY_DCUGCR_RCSW_MASK		0xffff
#define ATLAS7_MEMC_PHY_DCUGCR_RCSW_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_DCUTPR */
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT0_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT0_SHIFT		0
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT1_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT1_SHIFT		8
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT2_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT2_SHIFT		16
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT3_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUTPR_TDCUT3_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DCUSR0 */
#define ATLAS7_MEMC_PHY_DCUSR0_RDONE		BIT(0)
#define ATLAS7_MEMC_PHY_DCUSR0_CFAIL		BIT(1)
#define ATLAS7_MEMC_PHY_DCUSR0_CFULL		BIT(2)

/* fields for register ATLAS7_MEMC_PHY_DCUSR1 */
#define ATLAS7_MEMC_PHY_DCUSR1_RDCNT_MASK		0xffff
#define ATLAS7_MEMC_PHY_DCUSR1_RDCNT_SHIFT		0
#define ATLAS7_MEMC_PHY_DCUSR1_FLCNT_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUSR1_FLCNT_SHIFT		16
#define ATLAS7_MEMC_PHY_DCUSR1_LPCNT_MASK		0xff
#define ATLAS7_MEMC_PHY_DCUSR1_LPCNT_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_BISTRR */
#define ATLAS7_MEMC_PHY_BISTRR_BINST_MASK		0x7
#define ATLAS7_MEMC_PHY_BISTRR_BINST_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTRR_BMODE		BIT(3)
#define ATLAS7_MEMC_PHY_BISTRR_BINF		BIT(4)
#define ATLAS7_MEMC_PHY_BISTRR_NFAIL_MASK		0xff
#define ATLAS7_MEMC_PHY_BISTRR_NFAIL_SHIFT		5
#define ATLAS7_MEMC_PHY_BISTRR_BSONF		BIT(13)
#define ATLAS7_MEMC_PHY_BISTRR_BDXEN		BIT(14)
#define ATLAS7_MEMC_PHY_BISTRR_BACEN		BIT(15)
#define ATLAS7_MEMC_PHY_BISTRR_BDMEN		BIT(16)
#define ATLAS7_MEMC_PHY_BISTRR_BDPAT_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTRR_BDPAT_SHIFT		17
#define ATLAS7_MEMC_PHY_BISTRR_BDXSEL_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTRR_BDXSEL_SHIFT		19
#define ATLAS7_MEMC_PHY_BISTRR_BCKSEL_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTRR_BCKSEL_SHIFT		23
#define ATLAS7_MEMC_PHY_BISTRR_BCCSEL_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTRR_BCCSEL_SHIFT		25

/* fields for register ATLAS7_MEMC_PHY_BISTWCR */
#define ATLAS7_MEMC_PHY_BISTWCR_BWCNT_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTWCR_BWCNT_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTMSKR0 */
#define ATLAS7_MEMC_PHY_BISTMSKR0_AMSK_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTMSKR0_AMSK_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTMSKR0_BAMSK_MASK		0x7
#define ATLAS7_MEMC_PHY_BISTMSKR0_BAMSK_SHIFT		16
#define ATLAS7_MEMC_PHY_BISTMSKR0_WEMSK		BIT(19)
#define ATLAS7_MEMC_PHY_BISTMSKR0_CKEMSK_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTMSKR0_CKEMSK_SHIFT		20
#define ATLAS7_MEMC_PHY_BISTMSKR0_CSMSK_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTMSKR0_CSMSK_SHIFT		24
#define ATLAS7_MEMC_PHY_BISTMSKR0_ODTMSK_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTMSKR0_ODTMSK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTMSKR1 */
#define ATLAS7_MEMC_PHY_BISTMSKR1_RASMSK		BIT(0)
#define ATLAS7_MEMC_PHY_BISTMSKR1_CASMSK		BIT(1)
#define ATLAS7_MEMC_PHY_BISTMSKR1_PARMSK		BIT(27)
#define ATLAS7_MEMC_PHY_BISTMSKR1_DMMSK_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTMSKR1_DMMSK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTMSKR2 */
#define ATLAS7_MEMC_PHY_BISTMSKR2_DQMSK_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTMSKR2_DQMSK_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTLSR */
#define ATLAS7_MEMC_PHY_BISTLSR_SEED_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTLSR_SEED_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTAR0 */
#define ATLAS7_MEMC_PHY_BISTAR0_BCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_BISTAR0_BCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTAR0_BROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTAR0_BROW_SHIFT		12
#define ATLAS7_MEMC_PHY_BISTAR0_BBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_BISTAR0_BBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTAR1 */
#define ATLAS7_MEMC_PHY_BISTAR1_BRANK_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTAR1_BRANK_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTAR1_BMRANK_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTAR1_BMRANK_SHIFT		2
#define ATLAS7_MEMC_PHY_BISTAR1_BAINC_MASK		0xfff
#define ATLAS7_MEMC_PHY_BISTAR1_BAINC_SHIFT		4

/* fields for register ATLAS7_MEMC_PHY_BISTAR2 */
#define ATLAS7_MEMC_PHY_BISTAR2_BMCOL_MASK		0xfff
#define ATLAS7_MEMC_PHY_BISTAR2_BMCOL_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTAR2_BMROW_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTAR2_BMROW_SHIFT		12
#define ATLAS7_MEMC_PHY_BISTAR2_BMBANK_MASK		0x7
#define ATLAS7_MEMC_PHY_BISTAR2_BMBANK_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTUDPR */
#define ATLAS7_MEMC_PHY_BISTUDPR_BUDP0_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTUDPR_BUDP0_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTUDPR_BUDP1_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTUDPR_BUDP1_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_BISTGSR */
#define ATLAS7_MEMC_PHY_BISTGSR_BDONE		BIT(0)
#define ATLAS7_MEMC_PHY_BISTGSR_BACERR		BIT(1)
#define ATLAS7_MEMC_PHY_BISTGSR_BDXERR		BIT(2)
#define ATLAS7_MEMC_PHY_BISTGSR_PARBER_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTGSR_PARBER_SHIFT		16
#define ATLAS7_MEMC_PHY_BISTGSR_DMBER_MASK		0xff
#define ATLAS7_MEMC_PHY_BISTGSR_DMBER_SHIFT		20
#define ATLAS7_MEMC_PHY_BISTGSR_RASBER_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTGSR_RASBER_SHIFT		28
#define ATLAS7_MEMC_PHY_BISTGSR_CASBER_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTGSR_CASBER_SHIFT		30

/* fields for register ATLAS7_MEMC_PHY_BISTWER */
#define ATLAS7_MEMC_PHY_BISTWER_ACWER_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTWER_ACWER_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTWER_DXWER_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTWER_DXWER_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_BISTBER0 */
#define ATLAS7_MEMC_PHY_BISTBER0_ABER_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTBER0_ABER_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTBER1 */
#define ATLAS7_MEMC_PHY_BISTBER1_BABER_MASK		0x3f
#define ATLAS7_MEMC_PHY_BISTBER1_BABER_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTBER1_WEBER_MASK		0x3
#define ATLAS7_MEMC_PHY_BISTBER1_WEBER_SHIFT		6
#define ATLAS7_MEMC_PHY_BISTBER1_CKEBER_MASK		0xff
#define ATLAS7_MEMC_PHY_BISTBER1_CKEBER_SHIFT		8
#define ATLAS7_MEMC_PHY_BISTBER1_CSBER_MASK		0xff
#define ATLAS7_MEMC_PHY_BISTBER1_CSBER_SHIFT		16
#define ATLAS7_MEMC_PHY_BISTBER1_ODTBER_MASK		0xff
#define ATLAS7_MEMC_PHY_BISTBER1_ODTBER_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_BISTBER2 */
#define ATLAS7_MEMC_PHY_BISTBER2_DQBER0_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTBER2_DQBER0_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTBER3 */
#define ATLAS7_MEMC_PHY_BISTBER3_DQBER1_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTBER3_DQBER1_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_BISTWCSR */
#define ATLAS7_MEMC_PHY_BISTWCSR_ACWCNT_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTWCSR_ACWCNT_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTWCSR_DXWCNT_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTWCSR_DXWCNT_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_BISTFWR0 */
#define ATLAS7_MEMC_PHY_BISTFWR0_AWEBS_MASK		0xffff
#define ATLAS7_MEMC_PHY_BISTFWR0_AWEBS_SHIFT		0
#define ATLAS7_MEMC_PHY_BISTFWR0_BAWEBS_MASK		0x7
#define ATLAS7_MEMC_PHY_BISTFWR0_BAWEBS_SHIFT		16
#define ATLAS7_MEMC_PHY_BISTFWR0_WEWEBS		BIT(19)
#define ATLAS7_MEMC_PHY_BISTFWR0_CKEWEBS_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTFWR0_CKEWEBS_SHIFT		20
#define ATLAS7_MEMC_PHY_BISTFWR0_CSWEBS_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTFWR0_CSWEBS_SHIFT		24
#define ATLAS7_MEMC_PHY_BISTFWR0_ODTWEBS_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTFWR0_ODTWEBS_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTFWR1 */
#define ATLAS7_MEMC_PHY_BISTFWR1_RASWEBS		BIT(0)
#define ATLAS7_MEMC_PHY_BISTFWR1_CASWEBS		BIT(1)
#define ATLAS7_MEMC_PHY_BISTFWR1_PARWEBS		BIT(26)
#define ATLAS7_MEMC_PHY_BISTFWR1_DMWEBS_MASK		0xf
#define ATLAS7_MEMC_PHY_BISTFWR1_DMWEBS_SHIFT		28

/* fields for register ATLAS7_MEMC_PHY_BISTFWR2 */
#define ATLAS7_MEMC_PHY_BISTFWR2_DQWEBS_MASK		0xffffffff
#define ATLAS7_MEMC_PHY_BISTFWR2_DQWEBS_SHIFT		0

/* fields for register ATLAS7_MEMC_PHY_AACR */
#define ATLAS7_MEMC_PHY_AACR_AATR_MASK		0x3fffffff
#define ATLAS7_MEMC_PHY_AACR_AATR_SHIFT		0
#define ATLAS7_MEMC_PHY_AACR_AAENC		BIT(30)
#define ATLAS7_MEMC_PHY_AACR_AAOENC		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_ZQ0CR0 */
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZDATA_MASK		0xfffff
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZDATA_SHIFT		0
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZDEN		BIT(28)
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZCALBYP		BIT(29)
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZCALEN		BIT(30)
#define ATLAS7_MEMC_PHY_ZQ0CR0_ZQPD		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_ZQ0CR1 */
#define ATLAS7_MEMC_PHY_ZQ0CR1_ZPROG_MASK		0xff
#define ATLAS7_MEMC_PHY_ZQ0CR1_ZPROG_SHIFT		0
#define ATLAS7_MEMC_PHY_ZQ0CR1_DFICU0		BIT(12)
#define ATLAS7_MEMC_PHY_ZQ0CR1_DFICU1		BIT(13)
#define ATLAS7_MEMC_PHY_ZQ0CR1_DFICCU		BIT(14)
#define ATLAS7_MEMC_PHY_ZQ0CR1_DFIPU0		BIT(16)
#define ATLAS7_MEMC_PHY_ZQ0CR1_DFIPU1		BIT(17)

/* fields for register ATLAS7_MEMC_PHY_ZQ0SR0 */
#define ATLAS7_MEMC_PHY_ZQ0SR0_ZCTRL_MASK		0xfffffff
#define ATLAS7_MEMC_PHY_ZQ0SR0_ZCTRL_SHIFT		0
#define ATLAS7_MEMC_PHY_ZQ0SR0_ZERR		BIT(30)
#define ATLAS7_MEMC_PHY_ZQ0SR0_ZDONE		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_ZQ0SR1 */
#define ATLAS7_MEMC_PHY_ZQ0SR1_ZPD_MASK		0x3
#define ATLAS7_MEMC_PHY_ZQ0SR1_ZPD_SHIFT		0
#define ATLAS7_MEMC_PHY_ZQ0SR1_ZPU_MASK		0x3
#define ATLAS7_MEMC_PHY_ZQ0SR1_ZPU_SHIFT		2
#define ATLAS7_MEMC_PHY_ZQ0SR1_OPD_MASK		0x3
#define ATLAS7_MEMC_PHY_ZQ0SR1_OPD_SHIFT		4
#define ATLAS7_MEMC_PHY_ZQ0SR1_OPU_MASK		0x3
#define ATLAS7_MEMC_PHY_ZQ0SR1_OPU_SHIFT		6

/* fields for register ATLAS7_MEMC_PHY_DX0GCR */
#define ATLAS7_MEMC_PHY_DX0GCR_DXEN		BIT(0)
#define ATLAS7_MEMC_PHY_DX0GCR_DQSODT		BIT(1)
#define ATLAS7_MEMC_PHY_DX0GCR_DQODT		BIT(2)
#define ATLAS7_MEMC_PHY_DX0GCR_DXIOM		BIT(3)
#define ATLAS7_MEMC_PHY_DX0GCR_DXPDD		BIT(4)
#define ATLAS7_MEMC_PHY_DX0GCR_DXPDR		BIT(5)
#define ATLAS7_MEMC_PHY_DX0GCR_DQSRPD		BIT(6)
#define ATLAS7_MEMC_PHY_DX0GCR_DSEN_MASK		0x3
#define ATLAS7_MEMC_PHY_DX0GCR_DSEN_SHIFT		7
#define ATLAS7_MEMC_PHY_DX0GCR_DQSRTT		BIT(9)
#define ATLAS7_MEMC_PHY_DX0GCR_DQRTT		BIT(10)
#define ATLAS7_MEMC_PHY_DX0GCR_RTTOH_MASK		0x3
#define ATLAS7_MEMC_PHY_DX0GCR_RTTOH_SHIFT		11
#define ATLAS7_MEMC_PHY_DX0GCR_RTTOAL		BIT(13)
#define ATLAS7_MEMC_PHY_DX0GCR_DXOEO_MASK		0x3
#define ATLAS7_MEMC_PHY_DX0GCR_DXOEO_SHIFT		14
#define ATLAS7_MEMC_PHY_DX0GCR_PLLRST		BIT(16)
#define ATLAS7_MEMC_PHY_DX0GCR_PLLPD		BIT(17)
#define ATLAS7_MEMC_PHY_DX0GCR_GSHIFT		BIT(18)
#define ATLAS7_MEMC_PHY_DX0GCR_PLLBYP		BIT(19)
#define ATLAS7_MEMC_PHY_DX0GCR_WLRKEN_MASK		0xf
#define ATLAS7_MEMC_PHY_DX0GCR_WLRKEN_SHIFT		26
#define ATLAS7_MEMC_PHY_DX0GCR_MDLEN		BIT(30)
#define ATLAS7_MEMC_PHY_DX0GCR_CALBYP		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_DX0GSR0 */
#define ATLAS7_MEMC_PHY_DX0GSR0_WDQCAL		BIT(0)
#define ATLAS7_MEMC_PHY_DX0GSR0_RDQSCAL		BIT(1)
#define ATLAS7_MEMC_PHY_DX0GSR0_RDQSNCAL		BIT(2)
#define ATLAS7_MEMC_PHY_DX0GSR0_GDQSCAL		BIT(3)
#define ATLAS7_MEMC_PHY_DX0GSR0_WLCAL		BIT(4)
#define ATLAS7_MEMC_PHY_DX0GSR0_WLDONE		BIT(5)
#define ATLAS7_MEMC_PHY_DX0GSR0_WLERR		BIT(6)
#define ATLAS7_MEMC_PHY_DX0GSR0_WLPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0GSR0_WLPRD_SHIFT		7
#define ATLAS7_MEMC_PHY_DX0GSR0_DPLOCK		BIT(15)
#define ATLAS7_MEMC_PHY_DX0GSR0_GDQSPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0GSR0_GDQSPRD_SHIFT		16
#define ATLAS7_MEMC_PHY_DX0GSR0_QSGERR_MASK		0xf
#define ATLAS7_MEMC_PHY_DX0GSR0_QSGERR_SHIFT		24
#define ATLAS7_MEMC_PHY_DX0GSR0_WLDQ		BIT(28)

/* fields for register ATLAS7_MEMC_PHY_DX0GSR1 */
#define ATLAS7_MEMC_PHY_DX0GSR1_DLTDONE		BIT(0)
#define ATLAS7_MEMC_PHY_DX0GSR1_DLTCODE_MASK		0xffffff
#define ATLAS7_MEMC_PHY_DX0GSR1_DLTCODE_SHIFT		1

/* fields for register ATLAS7_MEMC_PHY_DX0BDLR0 */
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ0WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ0WBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ1WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ1WBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ2WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ2WBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ3WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ3WBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ4WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR0_DQ4WBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX0BDLR1 */
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ5WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ5WBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ6WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ6WBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ7WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR1_DQ7WBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX0BDLR1_DMWBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR1_DMWBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX0BDLR1_DSWBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR1_DSWBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX0BDLR2 */
#define ATLAS7_MEMC_PHY_DX0BDLR2_DSOEBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR2_DSOEBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0BDLR2_DQOEBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR2_DQOEBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX0BDLR2_DSRBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR2_DSRBD_SHIFT		12

/* fields for register ATLAS7_MEMC_PHY_DX0BDLR3 */
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ0RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ0RBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ1RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ1RBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ2RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ2RBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ3RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ3RBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ4RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR3_DQ4RBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX0BDLR4 */
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ5RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ5RBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ6RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ6RBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ7RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR4_DQ7RBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX0BDLR4_DMRBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX0BDLR4_DMRBD_SHIFT		18

/* fields for register ATLAS7_MEMC_PHY_DX0LCDLR0 */
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R0WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R0WLD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R1WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R1WLD_SHIFT		8
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R2WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R2WLD_SHIFT		16
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R3WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR0_R3WLD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX0LCDLR1 */
#define ATLAS7_MEMC_PHY_DX0LCDLR1_WDQD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR1_WDQD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0LCDLR1_RDQSD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR1_RDQSD_SHIFT		8

/* fields for register ATLAS7_MEMC_PHY_DX0LCDLR2 */
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R0DQSGD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R0DQSGD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R1_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R1_SHIFT		8
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R2_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R2_SHIFT		16
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R3_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0LCDLR2_R3_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX0MDLR */
#define ATLAS7_MEMC_PHY_DX0MDLR_IPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0MDLR_IPRD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0MDLR_TPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0MDLR_TPRD_SHIFT		8
#define ATLAS7_MEMC_PHY_DX0MDLR_MDLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX0MDLR_MDLD_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_DX0GTR */
#define ATLAS7_MEMC_PHY_DX0GTR_R0DGSL_MASK		0x7
#define ATLAS7_MEMC_PHY_DX0GTR_R0DGSL_SHIFT		0
#define ATLAS7_MEMC_PHY_DX0GTR_R0WLSL_MASK		0x3
#define ATLAS7_MEMC_PHY_DX0GTR_R0WLSL_SHIFT		12

/* fields for register ATLAS7_MEMC_PHY_DX0GSR2 */
#define ATLAS7_MEMC_PHY_DX0GSR2_RDERR		BIT(0)
#define ATLAS7_MEMC_PHY_DX0GSR2_RDWN		BIT(1)
#define ATLAS7_MEMC_PHY_DX0GSR2_WDERR		BIT(2)
#define ATLAS7_MEMC_PHY_DX0GSR2_WDWN		BIT(3)
#define ATLAS7_MEMC_PHY_DX0GSR2_REERR		BIT(4)
#define ATLAS7_MEMC_PHY_DX0GSR2_REWN		BIT(5)
#define ATLAS7_MEMC_PHY_DX0GSR2_WEERR		BIT(6)
#define ATLAS7_MEMC_PHY_DX0GSR2_WEWN		BIT(7)
#define ATLAS7_MEMC_PHY_DX0GSR2_ESTAT_MASK		0xf
#define ATLAS7_MEMC_PHY_DX0GSR2_ESTAT_SHIFT		8

/* fields for register ATLAS7_MEMC_PHY_DX1GCR */
#define ATLAS7_MEMC_PHY_DX1GCR_DXEN		BIT(0)
#define ATLAS7_MEMC_PHY_DX1GCR_DQSODT		BIT(1)
#define ATLAS7_MEMC_PHY_DX1GCR_DQODT		BIT(2)
#define ATLAS7_MEMC_PHY_DX1GCR_DXIOM		BIT(3)
#define ATLAS7_MEMC_PHY_DX1GCR_DXPDD		BIT(4)
#define ATLAS7_MEMC_PHY_DX1GCR_DXPDR		BIT(5)
#define ATLAS7_MEMC_PHY_DX1GCR_DQSRPD		BIT(6)
#define ATLAS7_MEMC_PHY_DX1GCR_DSEN_MASK		0x3
#define ATLAS7_MEMC_PHY_DX1GCR_DSEN_SHIFT		7
#define ATLAS7_MEMC_PHY_DX1GCR_DQSRTT		BIT(9)
#define ATLAS7_MEMC_PHY_DX1GCR_DQRTT		BIT(10)
#define ATLAS7_MEMC_PHY_DX1GCR_RTTOH_MASK		0x3
#define ATLAS7_MEMC_PHY_DX1GCR_RTTOH_SHIFT		11
#define ATLAS7_MEMC_PHY_DX1GCR_RTTOAL		BIT(13)
#define ATLAS7_MEMC_PHY_DX1GCR_DXOEO_MASK		0x3
#define ATLAS7_MEMC_PHY_DX1GCR_DXOEO_SHIFT		14
#define ATLAS7_MEMC_PHY_DX1GCR_PLLRST		BIT(16)
#define ATLAS7_MEMC_PHY_DX1GCR_PLLPD		BIT(17)
#define ATLAS7_MEMC_PHY_DX1GCR_GSHIFT		BIT(18)
#define ATLAS7_MEMC_PHY_DX1GCR_PLLBYP		BIT(19)
#define ATLAS7_MEMC_PHY_DX1GCR_WLRKEN_MASK		0xf
#define ATLAS7_MEMC_PHY_DX1GCR_WLRKEN_SHIFT		26
#define ATLAS7_MEMC_PHY_DX1GCR_MDLEN		BIT(30)
#define ATLAS7_MEMC_PHY_DX1GCR_CALBYP		BIT(31)

/* fields for register ATLAS7_MEMC_PHY_DX1GSR0 */
#define ATLAS7_MEMC_PHY_DX1GSR0_WDQCAL		BIT(0)
#define ATLAS7_MEMC_PHY_DX1GSR0_RDQSCAL		BIT(1)
#define ATLAS7_MEMC_PHY_DX1GSR0_RDQSNCAL		BIT(2)
#define ATLAS7_MEMC_PHY_DX1GSR0_GDQSCAL		BIT(3)
#define ATLAS7_MEMC_PHY_DX1GSR0_WLCAL		BIT(4)
#define ATLAS7_MEMC_PHY_DX1GSR0_WLDONE		BIT(5)
#define ATLAS7_MEMC_PHY_DX1GSR0_WLERR		BIT(6)
#define ATLAS7_MEMC_PHY_DX1GSR0_WLPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1GSR0_WLPRD_SHIFT		7
#define ATLAS7_MEMC_PHY_DX1GSR0_DPLOCK		BIT(15)
#define ATLAS7_MEMC_PHY_DX1GSR0_GDQSPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1GSR0_GDQSPRD_SHIFT		16
#define ATLAS7_MEMC_PHY_DX1GSR0_QSGERR_MASK		0xf
#define ATLAS7_MEMC_PHY_DX1GSR0_QSGERR_SHIFT		24
#define ATLAS7_MEMC_PHY_DX1GSR0_WLDQ		BIT(28)

/* fields for register ATLAS7_MEMC_PHY_DX1GSR1 */
#define ATLAS7_MEMC_PHY_DX1GSR1_DLTDONE		BIT(0)
#define ATLAS7_MEMC_PHY_DX1GSR1_DLTCODE_MASK		0xffffff
#define ATLAS7_MEMC_PHY_DX1GSR1_DLTCODE_SHIFT		1

/* fields for register ATLAS7_MEMC_PHY_DX1BDLR0 */
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ0WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ0WBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ1WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ1WBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ2WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ2WBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ3WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ3WBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ4WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR0_DQ4WBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX1BDLR1 */
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ5WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ5WBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ6WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ6WBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ7WBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR1_DQ7WBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX1BDLR1_DMWBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR1_DMWBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX1BDLR1_DSWBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR1_DSWBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX1BDLR2 */
#define ATLAS7_MEMC_PHY_DX1BDLR2_DSOEBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR2_DSOEBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1BDLR2_DQOEBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR2_DQOEBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX1BDLR2_DSRBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR2_DSRBD_SHIFT		12

/* fields for register ATLAS7_MEMC_PHY_DX1BDLR3 */
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ0RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ0RBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ1RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ1RBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ2RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ2RBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ3RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ3RBD_SHIFT		18
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ4RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR3_DQ4RBD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX1BDLR4 */
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ5RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ5RBD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ6RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ6RBD_SHIFT		6
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ7RBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR4_DQ7RBD_SHIFT		12
#define ATLAS7_MEMC_PHY_DX1BDLR4_DMRBD_MASK		0x3f
#define ATLAS7_MEMC_PHY_DX1BDLR4_DMRBD_SHIFT		18

/* fields for register ATLAS7_MEMC_PHY_DX1LCDLR0 */
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R0WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R0WLD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R1WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R1WLD_SHIFT		8
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R2WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R2WLD_SHIFT		16
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R3WLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR0_R3WLD_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX1LCDLR1 */
#define ATLAS7_MEMC_PHY_DX1LCDLR1_WDQD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR1_WDQD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1LCDLR1_RDQSD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR1_RDQSD_SHIFT		8

/* fields for register ATLAS7_MEMC_PHY_DX1LCDLR2 */
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R0DQSGD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R0DQSGD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R1_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R1_SHIFT		8
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R2_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R2_SHIFT		16
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R3_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1LCDLR2_R3_SHIFT		24

/* fields for register ATLAS7_MEMC_PHY_DX1MDLR */
#define ATLAS7_MEMC_PHY_DX1MDLR_IPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1MDLR_IPRD_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1MDLR_TPRD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1MDLR_TPRD_SHIFT		8
#define ATLAS7_MEMC_PHY_DX1MDLR_MDLD_MASK		0xff
#define ATLAS7_MEMC_PHY_DX1MDLR_MDLD_SHIFT		16

/* fields for register ATLAS7_MEMC_PHY_DX1GTR */
#define ATLAS7_MEMC_PHY_DX1GTR_R0DGSL_MASK		0x7
#define ATLAS7_MEMC_PHY_DX1GTR_R0DGSL_SHIFT		0
#define ATLAS7_MEMC_PHY_DX1GTR_R0WLSL_MASK		0x3
#define ATLAS7_MEMC_PHY_DX1GTR_R0WLSL_SHIFT		12

/* fields for register ATLAS7_MEMC_PHY_DX1GSR2 */
#define ATLAS7_MEMC_PHY_DX1GSR2_RDERR		BIT(0)
#define ATLAS7_MEMC_PHY_DX1GSR2_RDWN		BIT(1)
#define ATLAS7_MEMC_PHY_DX1GSR2_WDERR		BIT(2)
#define ATLAS7_MEMC_PHY_DX1GSR2_WDWN		BIT(3)
#define ATLAS7_MEMC_PHY_DX1GSR2_REERR		BIT(4)
#define ATLAS7_MEMC_PHY_DX1GSR2_REWN		BIT(5)
#define ATLAS7_MEMC_PHY_DX1GSR2_WEERR		BIT(6)
#define ATLAS7_MEMC_PHY_DX1GSR2_WEWN		BIT(7)
#define ATLAS7_MEMC_PHY_DX1GSR2_ESTAT_MASK		0xf
#define ATLAS7_MEMC_PHY_DX1GSR2_ESTAT_SHIFT		8
